# simple illustration client/server pair; client program sends a string
# to server, which echoes it back to the client (in multiple copies),
# and the latter prints to the screen
# this is the server

import socket
import sys
import objc
import time
import threading
from AppKit import NSScreen

width, height = int(NSScreen.mainScreen().frame().size.width), int(NSScreen.mainScreen().frame().size.height)

class ETMouse():
	def setMousePosition(self, x, y):
		bndl = objc.loadBundle('CoreGraphics', globals(), '/System/Library/Frameworks/ApplicationServices.framework')
		objc.loadBundleFunctions(bndl, globals(), [('CGWarpMouseCursorPosition', 'v{CGPoint=ff}')])
		CGWarpMouseCursorPosition((x, y))

# create a socket
s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
# associate the socket with a port
host = '' # can leave this blank on the server side
port = int(sys.argv[1])
s.bind((host, port))

# accept "call" from client
s.listen(1)
global conn
conn, addr = s.accept()
print 'client is at', addr

# read string from client (assumed here to be so short that one call to
# recv() is enough), and make multiple copies (to show the need for the
# "while" loop on the client side)

global et
global l3x
global l3y
global lx
global ly

et = ETMouse()
l3x = [width/2, width/2, width/2]
l3y = [height/2, height/2, height/2]
lx=l3x[0]
ly=l3y[0]

def average(a):
	b = len(a)
	c = 0
	for i in a:
		c = c+i
	return c/b

class Serverservice (threading.Thread):
	def run (self):
		global l3x
		global l3y
		global conn
		for i in range (1000):
			data = conn.recv(1024)
			print data
			[x, y, z] = eval(data.split("\n")[-2])
			l3x = l3x[1:]
			l3y = l3y[1:]
			l3x.append(int(x))
			l3y.append(int(y))

class Mousecontrol (threading.Thread):
	def run (self):
		global l3x
		global l3y
		global lx
		global ly
		global et
		for i in range(100000):
			print lx
			#smooth inputs by averaging last 3 readings
			x = (average(l3x)/1400.0+0.5)*height
			y = (average (l3y)/1400.0+0.5)*width
			et.setMousePosition(average([ly,y]), average([lx, x]))
			lx = x
			ly = y
			time.sleep(0.05)
	
Serverservice().start()
Mousecontrol().start()